// ==UserScript==
// @name           HTML5 video full-screen
// @namespace      http://rauscheronline.de
// @description    adds fullscreen capability to every <video>
// 				   just play the video and then hit SHIFT-ENTER or F11
// @include        *
// ==/UserScript==

// Version 1.1

(function(){
window.addEventListener('DOMContentLoaded',init,false);
window.addEventListener('DOMContentLoaded',function(){
	document.body.addEventListener('keydown',keyDownHandler,false);
},false);
window.addEventListener('DOMNodeInserted',init,false);
window.addEventListener('resize',resizeHandle,false);
var curVid=null;
var isFullscreen=false;
function init()
{
	videos = document.querySelectorAll("video");

	for (var i=0, video; video=videos[i]; i++)
	{
		if (!video.myFullScreenEnabled)
		{
			video.addEventListener('play',playHandler,false);
			video.addEventListener('stop',stopPauseHandler,false);
			video.addEventListener('pause',stopPauseHandler,false);
			video.myFullScreenEnabled = true;
			//alert(video);
		}
	}
}

function playHandler(e)
{
	//alert("das ist" + this)
	if ((""+this) != "[object HTMLVideoElement]") //how to do this right?
		return;
	
	curVid = this;
}

function stopPauseHandler(e)
{
	if ((""+this) != "[object HTMLVideoElement]") //how to do this right?
		return;
	
	if (curVid == this)
	{
		if (isFullscreen)
			restoreScreen(this);
		curVid=null; //no we can use F11 without making the video FS again...
	}
}

function keyDownHandler(e)
{
	//alert("key "+curVid +" e "+e.keyCode+" "+e.shiftKey);
	if (curVid==null)
		return;
	
	//alt+enter  or F11 
	if ((e.keyCode+""=="13"&&e.shiftKey)||e.keyCode+""=="122")
	{
		if (isFullscreen)
		{
			restoreScreen(curVid);
		}
		else
		{
			makeFullscreen(curVid);
		}
	}
}

//saves old style and sets new style to
/*video{ 
position: fixed;
top: 0;
left: 0;
width: <clientwidth>px;
height: <clientheight>px;
z-index: 1000000;
background-color: rgba(0,0,0,0.9);
}*/
var backup = null;
var oldVid;
function makeFullscreen(video)
{
	if (backup!=null)
		restoreScreen(video);
		
	//backup old state
	oldVid=video;
	backup= new Object();
	backup.position 		= video.style.position;
	backup.top 				= video.style.top;
	backup.left 			= video.style.left;
	backup.width 			= video.style.width;
	backup.height 			= video.style.height;
	backup.zIndex 			= video.style.zIndex;
	backup.backgroundColor 	= video.style.backgroundColor;
	backup.border			= video.style.border;
	
	video.style.position		= "fixed";
	video.style.top				= 0;
	video.style.left			= 0;
	video.style.width			= window.innerWidth+"px";
	video.style.height			= window.innerHeight+"px";
	video.style.zIndex			= 1000000000;
	video.style.backgroundColor	= "rgba(0,0,0,0.9)";
	video.style.border			= "none";
	
	isFullscreen=true;
}

function restoreScreen(video)
{
	//restore old state
	video.style.position		= backup.position; 		 
	video.style.top				= backup.top; 			
	video.style.left			= backup.left; 			 
	video.style.width			= backup.width; 			 
	video.style.height			= backup.height; 			 
	video.style.zIndex			= backup.zIndex;
	video.style.backgroundColor	= backup.backgroundColor;
	video.style.border			= backup.border;
	
	isFullscreen=false;
}

function resizeHandle()
{
	if (isFullscreen)
	{
		curVid.style.width			= window.innerWidth+"px";
		curVid.style.height			= window.innerHeight+"px";
	}
}

})();
